jjb: lttng-tools: cleanup indentation in build.sh
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
97# Find the most recent GCC version supported by the kernel sources
98select_compiler() {
99 local selected_cc
100
101 cd "$LINUX_SRCOBJ_DIR"
102
103 kversion=$(make -s kernelversion)
104
105 set +e
106
2456f978 107 for cc in gcc-8 gcc-5 gcc-4.8; do
5a196804
MJ
108 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
109 selected_cc="$cc"
110 break
111 fi
112 done
113
114 set -e
115
116 if [ "x$selected_cc" = "x" ]; then
117 echo "Found no suitable compiler."
118 exit 1
119 fi
120
1d5a0a3c
MJ
121 # Force gcc-4.8 for kernels before 3.18
122 if { verlt "$kversion" "3.18"; }; then
23db2292 123 selected_cc=gcc-4.8
7e02032c
MJ
124 fi
125
425e4992
MJ
126 if [ "$selected_cc" != "gcc-4.8" ]; then
127 # Older kernel Makefiles do not expect the compiler to default to PIE
128 KAFLAGS="-fno-pie"
c45b04df 129 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
130 KCPPFLAGS="-fno-pie"
131 export KAFLAGS KCFLAGS KCPPFLAGS
132 fi
133
5a196804 134 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 135 export HOSTCC="${selected_cc}"
5a196804
MJ
136
137 cd -
138}
139
140
141build_linux_kernel() {
142 cd "$LINUX_SRCOBJ_DIR"
143
144 kversion=$(make -s kernelversion)
145
7e02032c 146 # Generate kernel configuration
a1ae361e 147 case "$ktag" in
7e02032c 148 Ubuntu*)
39961776 149 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 150 if vergte "${kversion}" "4.10"; then
39961776
MJ
151 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
152 exit 0
153 fi
154 fi
af101606
MJ
155
156 # Disable riscv64 config generation, we don't have a toolchain on bionic
157 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
158
073dc82c
MJ
159 # Hack for kernel Ubuntu-hwe-5.8
160 if [ ! -f "debian/compat" ]; then
161 echo "10" > "debian/compat"
162 fi
163
a46abb0a
MJ
164 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
165 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 166 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 167 ;;
c45b04df 168
7e02032c 169 *)
16844a6d
MJ
170 # Force 32bit build on i386, default is 64bit
171 if [ "$arch" = "i386" ]; then
5a196804
MJ
172 export ARCH="i386"
173 fi
174
175 # allyesconfig is mostly broken for kernels of the 2.6 series
176 if verlt "$kversion" "3.0"; then
177 vanilla_config="defconfig"
7a76a4d0
MJ
178 fi
179
5a196804 180 make "${vanilla_config}"
7e02032c
MJ
181 ;;
182 esac
183
53b51a15 184 # oldnoconfig was renamed in 4.19
5a196804 185 if vergte "$kversion" "4.19"; then
53b51a15 186 update_conf_target="olddefconfig"
5a196804 187 else
53b51a15 188 update_conf_target="oldnoconfig"
5a196804
MJ
189 fi
190
191 # Fix 'defined(@array)' was removed from recent perl
192 if [ -f "kernel/timeconst.pl" ]; then
193 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
194 fi
195
196 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 197 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
198 if [ -f "arch/x86/kvm/svm.c" ]; then
199 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
200 fi
201
202 if [ -f "arch/x86/kvm/vmx.c" ]; then
203 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
204 fi
205 fi
206
53b51a15
MJ
207 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
208 # Convert them to 'cmpw' which was previously done silently
209 if verlt "$kversion" "4.9"; then
210 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
211 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
212 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
213 fi
214
5a196804
MJ
215 # Fix a typo in v2.6.36.x
216 if [ -f "arch/x86/kernel/entry_64.S" ]; then
217 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
218 fi
219
53b51a15
MJ
220 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
221 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
222 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
223 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
224 fi
225
5a196804
MJ
226 # Fix kernel < 3.0 with gcc >= 4.7
227 if verlt "$kversion" "3.0"; then
228 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
229 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
230 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
231 echo "header-y += linkage.h" >> include/linux/Kbuild
232 fi
233
7e02032c 234 # GCC 4.8
53b51a15
MJ
235 if [ "$HOSTCC" == "gcc-4.8" ]; then
236 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
237 fi
7e02032c
MJ
238
239 # Don't try to sign modules
53b51a15 240 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 241
9ef18fa2 242 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 243 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
244
245 # Cause problems with inline assembly on i386
53b51a15 246 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 247
1d5a0a3c 248 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
249 scripts/config --disable CONFIG_SAMPLES
250 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
251
252 # Disable kcov
53b51a15 253 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
254
255 # Broken on some RT kernels
53b51a15 256 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 257
1e300ea9 258 # Broken drivers
53b51a15
MJ
259 scripts/config --disable CONFIG_RAPIDIO_TSI721
260 scripts/config --disable CONFIG_SGI_XP
261 scripts/config --disable CONFIG_MFD_WM8994
262 scripts/config --disable CONFIG_DRM_RADEON
263 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 264
5a196804
MJ
265 # IGBVF won't build with recent gcc on 2.6.38.x
266 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 267 scripts/config --disable CONFIG_IGBVF
5a196804 268 fi
9ef18fa2 269
c72041eb
MJ
270 # Don't fail the build on warnings
271 scripts/config --disable CONFIG_WERROR
272
51fa2ab3 273 # Set required options
53b51a15
MJ
274 scripts/config --enable CONFIG_TRACEPOINTS
275 scripts/config --enable CONFIG_KALLSYMS
276 scripts/config --enable CONFIG_HIGH_RES_TIMERS
277 scripts/config --enable CONFIG_KPROBES
278 scripts/config --enable CONFIG_FTRACE
279 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
280 scripts/config --enable CONFIG_KALLSYMS_ALL
281 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
282 scripts/config --enable CONFIG_PERF_EVENTS
283 scripts/config --enable CONFIG_EVENT_TRACING
284 scripts/config --enable CONFIG_KRETPROBES
7e02032c 285
1d28ffce
MJ
286 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
287 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
288
7a76a4d0 289 # Debug
5a196804
MJ
290 #cat .config
291
292 make "$update_conf_target" CC="$CC"
293 make -j"$NPROC" CC="$CC"
294
c45b04df 295 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
296
297 # Save the kernel and modules
298 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 299 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 300 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
301 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
302 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
303 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
304}
305
306
307extract_distro_headers() {
308
309 # Enter linux source dir
310 cd "${LINUX_SRCOBJ_DIR}"
311
312
313 # For RT kernels, copy version file
314 if [ -s localversion-rt ]; then
315 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
316 fi
317
318 # Copy all Makefile related stuff
319 find . -path './include/*' -prune \
320 -o -path './scripts/*' -prune -o -type f \
321 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
322 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
323 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
324
325 # Copy base scripts and include dirs
326 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 327
5a196804
MJ
328 # Copy arch includes
329 (find arch -name include -type d -print0 | \
330 xargs -0 -n1 -i: find : -type f) | \
331 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
332
333 # Copy arch scripts
334 (find arch -name scripts -type d -print0 | \
335 xargs -0 -n1 -i: find : -type f) | \
336 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
337
338 # Cleanup scripts
339 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
340 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
341
04873cc3 342 # On powerpc 32bits this object is required to link modules
5a196804 343 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
344 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
345 :
346 else
04873cc3
MJ
347 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
348 fi
5a196804
MJ
349 fi
350
351 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
352 if [ "${karch}" = "arm64" ]; then
353 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
354 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
355 fi
356 fi
357
358 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
359 if [ -f tools/objtool/objtool ]; then
360 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
361 fi
362
363 if [ -f "arch/x86/kernel/macros.s" ]; then
364 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
365 fi
366
367 # Copy modules related stuff, if available
368 if [ -s Module.symvers ]; then
369 cp Module.symvers "${LINUX_HDROBJ_DIR}"
370 fi
371
372 if [ -s System.map ]; then
373 cp System.map "${LINUX_HDROBJ_DIR}"
374 fi
375
376 if [ -s Module.markers ]; then
377 cp Module.markers "${LINUX_HDROBJ_DIR}"
378 fi
379
380 # Copy config file
381 cp .config "${LINUX_HDROBJ_DIR}"
382
383 # Make sure the Makefile and version.h have a matching timestamp so that
384 # external modules can be built
385 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
386 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
387 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
388 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
389 else
390 echo "Missing version.h"
391 exit 1
392 fi
393 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
394
395 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
396 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
397 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
398 fi
5a196804
MJ
399
400 # Finally clean the object files from the full source tree
401 make clean
402
403 # And regen the modules support files
404 make modules_prepare CC="$CC"
51fa2ab3 405
04873cc3 406 # On powerpc 32bits this object is required to link modules
d815b018 407 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
408 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
409 :
410 else
04873cc3
MJ
411 make arch/powerpc/lib/crtsavres.o CC="$CC"
412 fi
d815b018
MJ
413 fi
414
7a76a4d0 415 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 416 if [ "${karch}" = "arm64" ]; then
c236528e 417 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 418 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
419 fi
420 fi
421
7e02032c 422 # Version specific tasks
a1ae361e 423 case "$ktag" in
7e02032c
MJ
424 Ubuntu*)
425 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 426 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
427 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
428 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
429 ;;
430 esac
7e02032c
MJ
431}
432
433
339db64d
MJ
434build_modules() {
435
5a196804
MJ
436 local kdir="$1"
437 local outdir="$2"
438 local kversion
439
440 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 441
2456f978
MJ
442 # Try to catch some compatibility problems by turning some
443 # warnings into errors.
999a2aa0 444 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 445
339db64d 446 # Enter lttng-modules source dir
5a196804 447 cd "${MODULES_GIT_DIR}"
339db64d
MJ
448
449 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
450 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
451 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
452 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
453
454 set +e
455
456 # Build modules
51fa2ab3 457 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 458 ret=$?
339db64d 459
5a196804
MJ
460 set -e
461
339db64d 462 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 463 if [ "$ret" -eq 0 ]; then
e9b44189 464 echo "This build should have failed."
339db64d
MJ
465 exit 1
466 fi
467
468 # We have to publish at least one file or the build will fail
5a196804 469 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 470
5a196804 471 KERNELDIR="${kdir}" make clean
7e02032c 472
339db64d
MJ
473 else # Regular build
474
475 # Build modules against full kernel sources
51fa2ab3 476 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
477
478 # Install modules to build dir
5a196804 479 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
480
481 # Clean build dir
5a196804 482 KERNELDIR="${kdir}" make clean
339db64d
MJ
483 fi
484}
485
486
487## MAIN ##
488
f3d8604b
MJ
489# Use all CPU cores
490NPROC=$(nproc)
491
5a196804
MJ
492MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
493LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 494
5a196804
MJ
495LINUX_OBJ_DIR="${WORKSPACE}/linux"
496LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
497LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
498LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 499
5a196804
MJ
500MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
501MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 502
5a196804
MJ
503LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
504
505OBJ_STORE_URL="s3://jenkins"
506
507cd "$WORKSPACE"
508
509# Create build directories
510mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
511
512git_clone_modules_sources
339db64d 513
7e02032c 514# Setup cross compile env if available
39961776 515if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
516
517 case "$cross_arch" in
518 "armhf")
519 karch="arm"
520 cross_compile="arm-linux-gnueabihf-"
53b51a15 521 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
522 ubuntu_config="armhf-config.flavour.generic"
523 ;;
524
525 "arm64")
526 karch="arm64"
527 cross_compile="aarch64-linux-gnu-"
53b51a15 528 vanilla_config="defconfig"
7e02032c
MJ
529 ubuntu_config="arm64-config.flavour.generic"
530 ;;
531
532 "powerpc")
533 karch="powerpc"
534 cross_compile="powerpc-linux-gnu-"
e9b44189 535 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
536 ubuntu_config="powerpc-config.flavour.powerpc-smp"
537 ;;
538
539 "ppc64el")
540 karch="powerpc"
541 cross_compile="powerpc64le-linux-gnu-"
e9b44189 542 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
543 ubuntu_config="ppc64el-config.flavour.generic"
544 ;;
545
546 *)
51fa2ab3 547 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
548 exit 1
549 ;;
550 esac
339db64d 551
7e02032c
MJ
552 # Export variables used by Kbuild for cross compilation
553 export ARCH="${karch}"
554 export CROSS_COMPILE="${cross_compile}"
339db64d 555
7e02032c 556# Set arch specific values if we are not cross compiling
39961776 557elif [ "x${arch}" != "x" ]; then
e9b44189 558
7e02032c 559 case "$arch" in
16844a6d 560 "i386")
7e02032c 561 karch="x86"
e9b44189 562 vanilla_config="allyesconfig"
7e02032c
MJ
563 ubuntu_config="i386-config.flavour.generic"
564 ;;
565
16844a6d 566 "amd64")
7e02032c 567 karch="x86"
e9b44189 568 vanilla_config="allyesconfig"
7e02032c
MJ
569 ubuntu_config="amd64-config.flavour.generic"
570 ;;
571
572 "armhf")
573 karch="arm"
e9b44189 574 vanilla_config="allyesconfig"
7e02032c
MJ
575 ubuntu_config="armhf-config.flavour.generic"
576 ;;
577
578 "arm64")
579 karch="arm64"
e9b44189 580 vanilla_config="allyesconfig"
7e02032c
MJ
581 ubuntu_config="arm64-config.flavour.generic"
582 ;;
583
584 "powerpc")
585 karch="powerpc"
e9b44189 586 vanilla_config="allyesconfig"
7e02032c
MJ
587 ubuntu_config="powerpc-config.flavour.powerpc-smp"
588 ;;
589
590 "ppc64el")
591 karch="powerpc"
e9b44189 592 vanilla_config="allyesconfig"
7e02032c
MJ
593 ubuntu_config="ppc64el-config.flavour.generic"
594 ;;
595
596 *)
597 echo "Unsupported arch $arch"
598 exit 1
599 ;;
600 esac
601else
04873cc3 602 echo "No arch or cross_arch specified"
7e02032c
MJ
603 exit 1
604fi
339db64d 605
339db64d 606
b214d997 607
5a196804
MJ
608# First get the kernel build from the object store, or build it, if it's
609# not available.
339db64d 610
5a196804
MJ
611echo "# Setup endpoint
612host_base = obj.internal.efficios.com
613host_bucket = obj.internal.efficios.com
614bucket_location = us-east-1
615use_https = True
7e02032c 616
5a196804
MJ
617# Setup access keys
618access_key = jenkins
619secret_key = echo123456
339db64d 620
5a196804
MJ
621# Enable S3 v4 signature APIs
622signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 623
c45b04df 624url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 625obj_name="linux.tar.bz2"
87445931
MJ
626
627if [ "x${cross_arch}" = "x" ]; then
628 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
629else
630 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
631fi
632
5a196804 633obj_url="$obj_url_prefix/$obj_name"
339db64d 634
5a196804
MJ
635set +e
636s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
637ret=$?
638set -e
339db64d 639
5a196804
MJ
640case "$ret" in
641 "0")
642 extract_archive_obj
643 ;;
a1ae361e 644
5a196804
MJ
645 "12")
646 echo "File not found"
339db64d 647
5a196804
MJ
648 # Build all the things and upload
649 # then finish the module build...
339db64d 650
5a196804
MJ
651 git_clone_linux_sources
652 git_export_linux_sources
339db64d 653
5a196804 654 select_compiler
a1ae361e 655
5a196804
MJ
656 ## PREPARE FULL LINUX SOURCE TREE
657 build_linux_kernel
d138fc44 658
5a196804
MJ
659 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
660 extract_distro_headers
339db64d 661
5a196804 662 tar_archive_obj
339db64d 663
5a196804 664 upload_archive_obj
339db64d 665
5a196804 666 ;;
339db64d 667
5a196804
MJ
668 *)
669 echo "Unknown error? Abort"
670 exit 1
671 ;;
672esac
339db64d 673
5a196804 674select_compiler
f3d8604b 675
7e02032c 676## BUILD modules
5a196804
MJ
677# Either we downloaded a pre-build kernel or we built it and uploaded
678# the archive for future builds.
679
680cd "$WORKSPACE"
f3d8604b 681
339db64d 682# Build modules against full kernel sources
5a196804 683build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 684
339db64d 685# Build modules against kernel headers
5a196804 686build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 687
5a196804
MJ
688# Make sure some modules were actually built
689tree "${MODULES_OUTPUT_KSRC_DIR}"
690if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
691 echo "No modules built!"
692 exit 1
693fi
694
5a196804
MJ
695tree "${MODULES_OUTPUT_KHDR_DIR}"
696if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
697 echo "No modules built!"
698 exit 1
699fi
b214d997 700
f3d8604b 701# EOF
This page took 0.060705 seconds and 4 git commands to generate.